
' ***************************************************************************
' * WINMAKER 1.1                                                            *
' * ~~~~~~~~~~~~                                                                        *
' * Have a great GUI for your application                                   *
' * ........................................................................*
' * Freeware               > Version 1.1                                    *
' * ........................................................................*
' * Designer and Developer > Abhijeet S. Kaulgud                            *
' * Copyright              > askQBIS > 2000-2002                            *
' * Company                > askQB India Solutions.                         *
' * ........................................................................*
' * EmailID                > abhijitkaulgud@usa.net                         *
' * ........................................................................*
' * Mouse Routines Used : vsINPUT 1.0                                       *
' *                       vsMOUSE 3.1                                       *
' *                       Created by Stefan Vogt (Thanx Stefan Vogt)        *
' * ........................................................................*
' * Simple & Beautiful Font Routine (Copyright askQBIS)                     *
' * ........................................................................*
' ***************************************************************************

DECLARE SUB delay (count)
DECLARE SUB putFont (caption$, xpos!, ypos!)
DECLARE SUB windows (caption$, x, y, length, breadth, colour, titlebarcolour)
DECLARE FUNCTION Captionlength! (text$)
DECLARE SUB Button (text$, bx!, by!, pressed, colour)
DECLARE SUB vsMOUSE (action$, a1%, a2%, a3%, a4%)
DECLARE FUNCTION vsINTERR% (ax%, bx%, cx%, dx%)
DIM mouse1(0 TO 45) AS INTEGER
DIM SHARED windowId AS INTEGER
DIM SHARED windowstatus(50)
DIM SHARED closex1(50)
DIM SHARED closex2(50)
DIM SHARED closey1(50)
DIM SHARED closey2(50)
DIM SHARED tex$(150)
DIM SHARED bgcolor AS INTEGER

RESTORE DataForMouse
DEF SEG = VARSEG(mouse1(0))
FOR i% = 0 TO 52
  READ Byte$
  POKE VARPTR(mouse1(0)) + i%, VAL("&H" + Byte$)
NEXT

DataForMouse:
DATA 55,8b,ec,56,57,8b,76,0c,8b,04,8b,76,0a,8b,1c,8b,76,08,8b,0c,8b,76,06,8b
DATA 14,cd,21,8b,76,0c,89,04,8b,76,0a,89,1c,8b,76,08,89,0c,8b,76,06,89,14,5f
DATA 5e,5d,ca,08,00

REM ..........................................................................
SCREEN 13
FOR cl = 16 TO 31
COLOR cl
LOCATE 10, 16: PRINT "WINMAKER 1.1"
LOCATE 12, 12: PRINT "BY ABHIJEET KAULGUD"
delay 10000
NEXT cl
SLEEP 2
PAINT (1, 1), 9
windows "winmaker", 50, 40, 200, 100, 0, 4
putFont "Give your application", 68, 75
putFont "a sensational look", 80, 115
Button "abhijeet Kaulgud", 83, 150, 0, 8
halt: a$ = INKEY$: IF a$ = "" THEN GOTO halt
Button "abhijeet Kaulgud", 83, 150, 1, 8
SLEEP 1
SCREEN 12: CLS
bgcolor = 6
PAINT (1, 1), bgcolor
colour = 8

window1$ = "winmaker for making great guis                  by abhijeet"
windows window1$, 50, 30, 500, 230, colour, 8
putFont "absolutely free...", 100, 70
putFont "would you like to use these objects in your program", 100, 100
putFont "then just contact me through email.", 99, 120
putFont "i shall send the source code immediatelly.", 100, 140
putFont "find my email address in the readme file.", 100, 170
button1$ = "new window"
Button button1$, 375, 220, 0, 8
button2$ = "quit"
Button button2$, 475, 220, 0, 8
vsMOUSE "area", 0, 639, 0, 479
vsMOUSE "show", 0, 0, 0, 0
vsMOUSE "position", 300, 239, 0, 0

DO
vsMOUSE "get", 0, 0, 0, 0

IF mouseB% = 1 THEN

 SELECT CASE mouseX%
    CASE 372 TO 372 + Captionlength(button1$) + 3
          SELECT CASE mouseY%
               CASE 217 TO 217 + 18
                 Button button1$, 375, 220, 1, 8
              
                 vsMOUSE "hide", 0, 0, 0, 0
                 LINE (49, 279)-(551, 431), bgcolor, BF
                 windows "click new window to generate random size windows", 50, 280, 500 * RND, 150, INT(15 * RND), 9
                 vsMOUSE "show", 0, 0, 0, 0

               END SELECT
               
     CASE 472 TO 472 + Captionlength(button2$) + 3
           SELECT CASE mouseY%
                CASE 217 TO 217 + 18
                 Button button2$, 475, 220, 1, 8
                 vsMOUSE "hide", 0, 0, 0, 0
                 CLS
                 END
                 END SELECT
END SELECT
    
     FOR t = 1 TO windowId
       SELECT CASE mouseX%
       CASE closex1(t) TO closex2(t)
           SELECT CASE mouseY%
                CASE closey1(t) TO closey2(t)
                 IF t >= 2 AND windowstatus(t) = 1 THEN
                        vsMOUSE "hide", 0, 0, 0, 0
                        LINE (49, 279)-(551, 431), bgcolor, BF
                        windowstatus(t) = 0
                        vsMOUSE "show", 0, 0, 0, 0
                 END IF
           END SELECT
       END SELECT
      NEXT t


END IF

LOOP UNTIL INKEY$ = CHR$(27)

'----------------------------------------------------------------------------

SUB Button (text$, bx, by, pressed, colour)
wide = Captionlength(text$)
lightborder = 7
darkborder = 0
buttoncolor = colour
b1 = bx: b2 = by: b3 = b1 + wide: b4 = b2 + 15
offset = 3

IF pressed = 0 THEN
        LINE (b1 - 3, b2 - 3)-(b3 - 2, b4 - 2), lightborder, B
        LINE (b1 - 2, b2 - 2)-(b3 - 1, b4 - 1), darkborder, B
        LINE (b1 - 2, b2 - 2)-(b3 - 2, b4 - 2), buttoncolor, BF
        putFont text$, b1 + 4, b2 + offset
ELSE
        vsMOUSE "hide", 0, 0, 0, 0
        LINE (b1 - 3, b2 - 3)-(b3 - 2, b4 - 2), darkborder, B
        LINE (b1 - 2, b2 - 2)-(b3 - 2, b4 - 2), 8, B
        LINE (b1 - 1, b2 - 1)-(b3 - 1, b4 - 1), buttoncolor, BF
        putFont text$, b1 + 6, b2 + offset + 1
        delay 25000
        LINE (b1 - 3, b2 - 3)-(b3 - 2, b4 - 2), lightborder, B
        LINE (b1 - 2, b2 - 2)-(b3 - 1, b4 - 1), darkborder, BF
        LINE (b1 - 2, b2 - 2)-(b3 - 2, b4 - 2), buttoncolor, BF
        putFont text$, b1 + 4, b2 + offset
        vsMOUSE "show", 0, 0, 0, 0
END IF
END SUB

FUNCTION Captionlength (text$)
lent = LEN(text$)
Captionlength = lent * 8 + 10
END FUNCTION

SUB delay (count)
FOR del = 0 TO count: NEXT del
END SUB

SUB putFont (caption$, xpos, ypos)

caption$ = UCASE$(caption$)
lent = LEN(caption$)
FOR i = 1 TO lent
tex$(i) = MID$(caption$, i, 1)
NEXT i

x = xpos
y = ypos
  
   FOR scan = 1 TO lent
        sp = ASC(tex$(scan))
        IF sp = 64 THEN
           x = x + 2
           PRESET (x + 2, y + 1), 0: sh = 0
           GOSUB at
           PRESET (x, y), 0: sh = 1
           GOSUB at
           x = x + 10
           GOTO cont
        END IF
        IF sp <> 32 THEN
                IF sp <> 46 THEN
                        PRESET (x + 2, y + 1), 0: sh = 0
                        r = ASC(tex$(scan)) - 64
                        ON r GOSUB a1, b1, c1, d1, e1, f1, g1, h1, i1, j1, k1, l1, m1, n1, o1, p1, q1, r1, s1, t1, u1, v1, w1, x1, y1, z1
                        PRESET (x, y), 0: sh = 1
                        r = ASC(tex$(scan)) - 64
                        ON r GOSUB a1, b1, c1, d1, e1, f1, g1, h1, i1, j1, k1, l1, m1, n1, o1, p1, q1, r1, s1, t1, u1, v1, w1, x1, y1, z1
                ELSE
                        PSET (x + 3, y + 5), 7
                        PSET (x + 4, y + 6), 0
                        x = x + 4
                        GOTO cont
                END IF

        END IF
                x = x + 8
cont: NEXT scan
   EXIT SUB

'................. Font.Routines .............................................

a1: a$ = "br0r4br1bd1d4u2l5d2u4"
IF sh = 0 THEN DRAW "c0 x" + VARPTR$(a$) ELSE DRAW "c7 x" + VARPTR$(a$)
RETURN
b1: B$ = "d5u5r4br1bd1d1bd1bl1l3r2br2d1bd1bl1l4"
IF sh = 0 THEN DRAW "c0 x" + VARPTR$(B$) ELSE DRAW "c7 x" + VARPTR$(B$)
RETURN
c1: c$ = "br1r4l4bl1bd1d3bd1br1r4"
IF sh = 0 THEN DRAW "c0 x" + VARPTR$(c$) ELSE DRAW "c7 x" + VARPTR$(c$)
RETURN
d1: d$ = "d5u5r4br1bd1d3bd1bl1l4"
IF sh = 0 THEN DRAW "c0 x" + VARPTR$(d$) ELSE DRAW "c7 x" + VARPTR$(d$)
RETURN
e1: e$ = "br1r4l4bl1bd1d2r4l4d1bd1br1r4"
IF sh = 0 THEN DRAW "c0 x" + VARPTR$(e$) ELSE DRAW "c7 x" + VARPTR$(e$)
RETURN
f1: f$ = "r5l5d3r3l3d2"
IF sh = 0 THEN DRAW "c0 x" + VARPTR$(f$) ELSE DRAW "c7 x" + VARPTR$(f$)
RETURN
g1: g$ = "br1r4l4bl1bd1d3bd1br1r4u2l2"
IF sh = 0 THEN DRAW "c0 x" + VARPTR$(g$) ELSE DRAW "c7 x" + VARPTR$(g$)
RETURN
h1: h$ = "d5u2r5u3d5"
IF sh = 0 THEN DRAW "c0 x" + VARPTR$(h$) ELSE DRAW "c7 x" + VARPTR$(h$)
RETURN
i1: i$ = "br1r4l2d5l2r4"
IF sh = 0 THEN DRAW "c0 x" + VARPTR$(i$) ELSE DRAW "c7 x" + VARPTR$(i$)
RETURN
j1: j$ = "br1r4l1d5l3u1"
IF sh = 0 THEN DRAW "c0 x" + VARPTR$(j$) ELSE DRAW "c7 x" + VARPTR$(j$)
RETURN
k1: k$ = "d5u1e4g2f2d1"
IF sh = 0 THEN DRAW "c0 x" + VARPTR$(k$) ELSE DRAW "c7 x" + VARPTR$(k$)
RETURN
l1: l$ = "d5r5"
IF sh = 0 THEN DRAW "c0 x" + VARPTR$(l$) ELSE DRAW "c7 x" + VARPTR$(l$)
RETURN
m1: m$ = "d5u5f2r1e2d5"
IF sh = 0 THEN DRAW "c0 x" + VARPTR$(m$) ELSE DRAW "c7 x" + VARPTR$(m$)
RETURN
n1: n$ = "d5u5f5u5"
IF sh = 0 THEN DRAW "c0 x" + VARPTR$(n$) ELSE DRAW "c7 x" + VARPTR$(n$)
RETURN
o1: o$ = "br1r3br1bd1d3bd1bl1l3bl1bu1u3"
IF sh = 0 THEN DRAW "c0 x" + VARPTR$(o$) ELSE DRAW "c7 x" + VARPTR$(o$)
RETURN
p1: p$ = "d5u5r4br1bd1d1bd1bl1l4"
IF sh = 0 THEN DRAW "c0 x" + VARPTR$(p$) ELSE DRAW "c7 x" + VARPTR$(p$)
RETURN
q1: q$ = "br1r3br1bd1d3bd1bl1l3bl1bu1u3bu1bf3f3"
IF sh = 0 THEN DRAW "c0 x" + VARPTR$(q$) ELSE DRAW "c7 x" + VARPTR$(q$)
RETURN
r1: r$ = "d5u5r4br1bd1d1bd1bl1l4r3f2"
IF sh = 0 THEN DRAW "c0 x" + VARPTR$(r$) ELSE DRAW "c7 x" + VARPTR$(r$)
RETURN
s1: s$ = "r5d1u1l5d3r5d2l5"
IF sh = 0 THEN DRAW "c0 x" + VARPTR$(s$) ELSE DRAW "c7 x" + VARPTR$(s$)
RETURN
t1: t$ = "br1r4l2d5"
IF sh = 0 THEN DRAW "c0 x" + VARPTR$(t$) ELSE DRAW "c7 x" + VARPTR$(t$)
RETURN
u1: u$ = "d4bd1br1r3br1bu1u4"
IF sh = 0 THEN DRAW "c0 x" + VARPTR$(u$) ELSE DRAW "c7 x" + VARPTR$(u$)
RETURN
v1: v$ = "d3f2e2u3"
IF sh = 0 THEN DRAW "c0 x" + VARPTR$(v$) ELSE DRAW "c7 x" + VARPTR$(v$)
RETURN
w1: w$ = "d5e2r1f2u5"
IF sh = 0 THEN DRAW "c0 x" + VARPTR$(w$) ELSE DRAW "c7 x" + VARPTR$(w$)
RETURN
x1: x$ = "r1d1f3d1r1bu5l1d1g3d1l1"
IF sh = 0 THEN DRAW "c0 x" + VARPTR$(x$) ELSE DRAW "c7 x" + VARPTR$(x$)
RETURN
y1: y$ = "d3r5u3d5l5"
IF sh = 0 THEN DRAW "c0 x" + VARPTR$(y$) ELSE DRAW "c7 x" + VARPTR$(y$)
RETURN
z1: z$ = "d1u1r5g5r5u1"
IF sh = 0 THEN DRAW "c0 x" + VARPTR$(z$) ELSE DRAW "c7 x" + VARPTR$(z$)
RETURN
at: at$ = "bd1d3bd1br1r3br1bu1u3l4br4bd4r1br1bu1u3h2l5g2d4f2r5"
IF sh = 0 THEN DRAW "c0 x" + VARPTR$(at$) ELSE DRAW "c7 x" + VARPTR$(at$)
RETURN

END SUB

SUB textfield
END SUB

FUNCTION vsINTERR% (a1%, a2%, a3%, a4%)

'----------------------------------------------------------------------------
SHARED mouse1() AS INTEGER

IF mouse1(0) <> 0 THEN
  a5% = VARPTR(mouse1%(0))
  DEF SEG = VARSEG(mouse1(0))
  POKE a5% + 26, &H33
  CALL ABSOLUTE(a1%, a2%, a3%, a4%, a5%)
  mouseInterr% = ax%
ELSE
  SCREEN 0
  PRINT : PRINT "Mouse error, program stopped"
  SYSTEM
END IF
'----------------------------------------------------------------------------

END FUNCTION

SUB vsMOUSE (action$, a1%, a2%, a3%, a4%)

'----------------------------------------------------------------------------
SHARED mouseX%, mouseY%, mouseB%

SELECT CASE action$
  CASE "get":      r% = vsINTERR%(3, mouseB%, mouseX%, mouseY%)
  CASE "show":     r% = vsINTERR%(1, bx%, cx%, dx%)
  CASE "hide":     r% = vsINTERR%(2, bx%, cx%, dx%)
  CASE "position": r% = vsINTERR%(4, bx%, a1%, a2%)
  CASE "area":     r% = vsINTERR%(7, 0, a1%, a2%)
                   r% = vsINTERR%(8, bx%, a3%, a4%)
  CASE "coord":    COLOR a3%
                   LOCATE a1%, a2%: PRINT "X"; mouseX%; "Y"; mouseY%; "    "
                   COLOR a4%
  CASE ELSE:       SCREEN 0
                   PRINT : PRINT "Error - Wrong mouse command"
                   SYSTEM
END SELECT
'----------------------------------------------------------------------------

END SUB

SUB windows (caption$, x, y, length, breadth, colour, titlebarcolour)
IF length <= 50 THEN length = 50
clen = Captionlength(caption$)
IF clen > length THEN
        z = ((length - 37) / 8)
        caption$ = LEFT$(caption$, z)
       
        IF length > 40 THEN
                caption$ = caption$ + "..."
        END IF
END IF

windowId = windowId + 1
IF windowId >= 50 THEN windowId = 1
windowstatus(windowId) = 1

lightborder = 7
darkborder = 0
wide = 15: bottom = 19
closecolor = 15         '       colour of Close button
       
        LINE (x - 1, y - 1)-(x + length, y + wide), lightborder, B
        LINE (x, y)-(x + length + 1, y + wide + 1), darkborder, B
        LINE (x, y)-(x + length, y + wide), titlebarcolour, BF
       
        LINE (x + length - 14, y + 2)-(x + length - 3, y + 13), lightborder, B
        LINE (x + length - 13, y + 3)-(x + length - 2, y + 14), darkborder, B
        LINE (x + length - 13, y + 3)-(x + length - 3, y + 13), titlebarcolour, BF

        LINE (x + length - 11, y + 5)-(x + length - 5, y + 11), closecolor
        LINE (x + length - 5, y + 5)-(x + length - 11, y + 11), closecolor
       
        closex1(windowId) = x + length - 13
        closex2(windowId) = x + length - 3
        closey1(windowId) = y + 3
        closey2(windowId) = y + 13

        LINE (x - 1, y + bottom - 1)-(x + length, y + breadth), lightborder, B
        LINE (x, y + bottom)-(x + length + 1, y + breadth + 1), darkborder, B
        LINE (x, y + bottom)-(x + length, y + breadth), colour, BF
      
        putFont caption$, x + 5, y + 5

END SUB

